;----------------------------------------------------------------------------
;    MODULE NAME:   DUMPVAR.X
;
;        $Author:   Dennis_Bareis  $
;      $Revision:   1.0  $
;          $Date:   15 May 1999 16:01:22  $
;       $Logfile:   E:/DB/PVCS.IT/OS2/REXXHDR/DUMPVAR.X_V  $
;         SOURCE:   http://www.labyrinth.net.au/~dbareis/index.htm (db0@anz.com)
;
;    DESCRIPTION:   Example program for "DUMPVAR.XH".
;
;                   Compile with "ppwizard DUMPVAR.X /rexx"
;----------------------------------------------------------------------------

/*
 * $Header:   E:/DB/PVCS.IT/OS2/REXXHDR/DUMPVAR.X_V   1.0   15 May 1999 16:01:22   Dennis_Bareis  $
 */

/*--- Include DUMPVAR header ------------------------------------------------*/
#include "DUMPVAR.XH"

/*--- Add trap handler for SYNTAX & NOVALUE errors --------------------------*/
signal on NOVALUE name RexxTrapUninitializedVariable;
signal on SYNTAX  name RexxTrapSyntaxError;

/*--- Say something! --------------------------------------------------------*/
say '*** We are about to trap, the trap handler will dump variables';
say '';

/*--- Trap ------------------------------------------------------------------*/
a = 'ASDF"' || '00'x || "qwerty'qwerty";
b = '0001'x;
c = 2;
another = '**** Should not see ***'
x = 'x another ''asdf'; F1.F2 = 88; F1.c = '6'; Fred = 9; F1.Fred = 99; y = 'asdf'; z = d2c(y) Here = a + b;

exit(255);






/*===========================================================================*/
CommonTrapHandler:
/*                                                                           */
/* arg(1) = Failing Line                                                     */
/* arg(2) = Type of trap (heading to be underlined)                          */
/* arg(3) = Trap specific Title  (text description)                          */
/* arg(4) = Trap specific Text                                               */
/*===========================================================================*/
   /*--- Work out some details based on passed info -------------------------*/
   FailingLine     = arg(1);
   TrapHeading     = 'BUG: ' || arg(2);
   TextDescription = arg(3);
   Text            = arg(4);

   /*--- Work out name of THIS rexx procedure -------------------------------*/
   parse source . . SourceFileName;

   /*--- Display details of the failing rexx code ---------------------------*/
   say copies('=+', 39);
   say TrapHeading;
   say copies('~', length(TrapHeading));
   say substr(TextDescription, 1 , 16) || ': ' || Text;
   say 'Failing Module  : ' || SourceFileName;
   say 'Failing Line #  : ' || FailingLine;
   say 'Failing Command : ' || strip(SourceLine(FailingLine));

   /*--- Dump variables METHOD 1 --------------------------------------------*/
   call DumpVarsInExpression SourceLine(FailingLine), '', 'VARIABLE LIST - METHOD #1';

   /*--- Dump variables METHOD 2 --------------------------------------------*/
   vlist.0 = 0;
   call DumpVarsInExpression SourceLine(FailingLine-1), 'vlist'
   call DumpVarsInExpression SourceLine(FailingLine),   'vlist'
   call DumpVarsInExpressionNow 'vlist', 'VARIABLE LIST - METHOD #2';
   say copies('=+', 39);

   /*--- We won't let a failure in one subprocedure stop others working -----*/
   exit(FailingLine);


/*===========================================================================*/
RexxTrapUninitializedVariable:
/*===========================================================================*/
   /*--- Process the trap (it never returns) --------------------------------*/
   call CommonTrapHandler SIGL, 'NoValue Abort!', 'Unknown Variable', condition('D');

/*===========================================================================*/
RexxTrapSyntaxError:
/*===========================================================================*/
   /*--- Process the trap (it never returns) --------------------------------*/
   call CommonTrapHandler SIGL, 'Syntax Error!', 'Reason', errortext(Rc);


